// -*-C++-*-
/*!
 * @file  CameraInfoSVC_impl.h
 * @brief Service implementation header of CameraInfo.idl
 *
 */

#include "CameraInfoSkel.h"


#ifndef CAMERAINFOSVC_IMPL_H
#define CAMERAINFOSVC_IMPL_H
 
/*
 * Example class implementing IDL interface CameraInfo
 */
class CameraInfoSVC_impl
 : public virtual POA_CameraInfo,
   public virtual PortableServer::RefCountServantBase
{
 private:
   // Make sure all instances are built on the heap by making the
   // destructor non-public
   //virtual ~CameraInfoSVC_impl();

 public:
   // standard constructor
   CameraInfoSVC_impl();
   virtual ~CameraInfoSVC_impl();

   // attributes and operations
   CORBA::Short getImageWidth();
   CORBA::Short getImageHeight();
   CORBA::Short getImageChannels();
   CORBA::Boolean getCameraParameter(RTC::TimedDoubleSeq& param);
   // image information
   int w, h, channels;
   // camera information
   double I[6], E[12];
};



#endif // CAMERAINFOSVC_IMPL_H


