//=============================================================================
//
//	control.h
//	2010.01.20 Tada 	  
//
//=============================================================================

//#ifndef __CONTROL_H
//#define __CONTROL_H

//=============================================================================
// System Includes
//=============================================================================
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <assert.h>
#include <sys/time.h>
#include <string.h>
#include <unistd.h>		
#include <math.h>
#include <float.h>
#include <limits.h>
#include <time.h>
#include <ctype.h>

//ソケット通信
#include <sys/fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include </usr/include/arpa/inet.h>
#include <netdb.h>

#include <fstream>

//=============================================================================
// libdc1394 Includes
//=============================================================================
#include <dc1394/conversions.h>
#include <dc1394/control.h>
#include <dc1394/utils.h>

#include <dc1394/log.h>
#include <dc1394/register.h>

//=============================================================================
// OpenCV Includes
//=============================================================================
#include <cv.h>
//#include "cvtest.h"
#include <cxcore.h>
#include <highgui.h>

//=============================================================================
// PGR Includes
//=============================================================================
#include "pgr_registers.h"
#include "pgr_stereocam.h"
#include "triclops.h"
#include "pnmutils.h"

#include "pgr_conversions.h"
#include "pgr_stereocam.h"
#include "pgr_registers.h"
//=============================================================================
//#include "stereo.h"
#include "Labeling.h"
#define STEREO_WIDTH 320//240
#define STEREO_HEIGHT 240//180
#define WIDTH 320
#define HEIGHT 240


class Bumblebee2Control{
public:
    Bumblebee2Control();
    ~Bumblebee2Control();
    int Initialize();
    int closeB();
    int getWidth();	
    int getHeight();
    int getChannels();
    int getColor();
    int triclopsInit();
    int triclopsProcess();
    int triclopsGetDisp(short int *);
    int getColorImage(IplImage *, IplImage *);
    int getMonoImage(IplImage *, IplImage *);
    int triclopsGetPoint(double *, double *, double *);
	int RGBtoGL(IplImage *, double *, double *, double *, double, double, double);
	int Distance(int, double *, double *, IplImage *, short);
	int InitBrightness2(IplImage *);
	int Brightness2(IplImage *, IplImage *, IplImage *);	
	int InitBrightness(IplImage *, IplImage *, IplImage *, IplImage *);	
	int Brightness(IplImage *, IplImage *, IplImage *, IplImage *, IplImage *, IplImage *, IplImage *, IplImage *);	
	//int Coordinate(int, int, float &, float &, float &TriclopsImage16);
	double timer_ms();
	int acs(char *, int, char *);
	void RectDetec(IplImage *, int *, int *, CvPoint *, CvPoint *);
	IplImage *IRgBy(IplImage *, IplImage *, IplImage *, CvPoint, CvPoint);
	IplImage *IRgBy2(IplImage *, IplImage *, IplImage *, CvPoint, CvPoint);
	double HeadDetect(CvPoint, CvPoint, float &, float &, float &, float &, int &, int &, int &, int &);
	double HeadDetect2(IplImage *, CvPoint, CvPoint, CvPoint &, CvPoint &, float &, float &, float &, int &, int &, short *);
	int InitMeanShift();
	int InitCamShift();
	int InitMotion();
	double LabelDetect(IplImage *, short *, CvPoint);
	IplImage *CamShift(IplImage *, IplImage *, IplImage *, CvBox2D &, CvBox2D &, short);
	IplImage *Labeling( IplImage *, IplImage *, short *);
	IplImage *Calibration(IplImage *, IplImage *);
	void update_mhi(IplImage *, IplImage *, int, CvPoint &);
	int Coordinate2(int, int, float &, float &, float &);

private:

	void MultiCS( IplImage *, IplImage *, IplImage *, CvHistogram *, int, CvRect, CvBox2D &, CvConnectedComp, short, int);
	CvScalar hsv2rgb(float);
	int Coordinate(int, int, float &, float &, float &);
    void cleanup_and_exit( dc1394camera_t* camera );
	float HalfAdjust(float);
	float change(float, float, float, float &, float &, float &);
	bool DoesExistZ(unsigned short, unsigned short *, int, int, float, float, float, int, int, float &, float &, float &);
	bool DoesExistZ2(unsigned short, unsigned short *, int, int, float, float, float, int, int, float &, float &, float &);
	double Logopp(unsigned char c, double &L);

	PGRStereoCamera_t stereoCamera, stereoCamera2;		//ステレオカメラのハンドル
    dc1394camera_t* camera;								//使用しているカメラのハンドル
    dc1394error_t err;									//error処理
    dc1394_t* d;										//バス全体のハンドル	
    dc1394camera_list_t* list;							//カメラの一覧を得る用
    TriclopsContext triclops;
	TriclopsImage image;
	TriclopsImage16 image16;
	TriclopsInput input;
    TriclopsError e;					//do stereo processing
    unsigned int nThisCam;
    unsigned int nBufferSize;
    unsigned char* pucDeInterlacedBuffer ;
    unsigned char* pucRGBBuffer ;
    unsigned char* pucGreenBuffer;

	IplImage *av_img, *sgm_img, *tmp_img, *lower_img, *upper_img;

	bool fixed_hist;						//初期化判定フラグ
	int select_object, select_object2, select_object3;			//初期追跡領域の設定判別フラグ値 (0: 設定なし, 1: 設定あり)
	int track_object, track_object2, track_object3;			//トラッキングの開始/停止用フラグ値 (0: 停止, -1: 開始, 1: トラッキング中)
	CvRect selection, selection2, selection3;				//矩形のオフセットとサイズ
	int backproject_mode;
	IplImage *hsv, *hue_cs, *mask_cs, *backproject, *histimg, *histimg2, *histimg_h, *histimg_h2;
	CvHistogram *hist, *hist2, *hist_h, *hist_h2;
	//int bin_w;
	CvRect track_window, track_window2, track_window3, track_window_h, track_window_h2;
	CvBox2D track_box, track_box2, track_box3;				//回転が考慮された2次元の箱
	CvConnectedComp track_comp, track_comp2, track_comp3;					//連結成分
	int hdims;							//ヒストグラムの次元数
	int vmin, vmax, smin;				//明度の最大値,明度の最小値,彩度の最小値
	float hranges_arr[];				//ヒストグラムのレンジ
	float* hranges;
	CvPoint origin, origin2, origin3;					//CamShiftトラッキング用変数
	int _theta;

	bool flag_mo;
	// ring image buffer
	IplImage **buf_m;
	int last;
	// temporary images
	IplImage *mhi; // MHI
	IplImage *orient; // orientation
	IplImage *mask_motion; // valid orientation mask
	IplImage *segmask; // motion segmentation map
	CvMemStorage* storage; // temporary storage

};

//#endif

